--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")


local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local InkedColorsHightlight = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 0.1}

local HightlightTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex"
local PushedTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex"

local ButtonSize = 40
local MySpacing = 1
local BorderSize = 12
local BorderPadding = 0

local MoverAB5 = CreateFrame("Frame","AB5Drag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	--MoverAB5:SetSize((ButtonSize * 12)+12, ButtonSize)
	MoverAB5:SetPoint("CENTER", UIParent,"BOTTOM",220.5, 65.5)
	MoverAB5:SetFrameStrata("FULLSCREEN_DIALOG")
	MoverAB5:SetClampedToScreen(true)
	MoverAB5:SetClampRectInsets(0, 0, 0,0)
local MoverAB5Text  = MoverAB5:CreateFontString(nil, "OVERLAY")
	MoverAB5Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.TTF", 15, "OUTLINE")
	MoverAB5Text:SetPoint("CENTER",MoverAB5,"CENTER", 0,0); 
	MoverAB5Text:SetText("")

local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		local point, relativeTo, relativePoint, xOfs, yOfs = MoverAB5:GetPoint(n)
			Inked.db.profile.MoverAB5X = xOfs
			Inked.db.profile.MoverAB5Y = yOfs
			Inked.db.profile.MoverAB5Point = point
			MoverAB5Text:SetText("Inked Bar 4")				
	end	
end	

local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe) 
local function CreateMoverBackdrop(frame)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
	insets = {top = -2, left = -2, bottom = -2, right = -2}})
	frame:SetBackdropColor(0,0.55,0.95,0.45)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function MakeBar5()
	if Inked.db.profile.UseActionBars == false then return end
	local Bar5holder = CreateFrame("Frame", "Bar5holder", UIParent, "SecureHandlerStateTemplate")
	Bar5holder:ClearAllPoints()
		

	ButtonSize = Inked.db.profile.AB5ButtonSize
	local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		if MultiBarRightButton1:IsVisible() then
		
			for i = 1, 12 do
					local Holder = CreateFrame("Frame",nil,UIParent)
						Holder:SetWidth(ButtonSize)
						Holder:SetHeight(ButtonSize)
						Holder:SetPoint("CENTER", _G["MultiBarRightButton"..i],"CENTER",0, 0)
						Holder:CreateBeautyBorder(BorderSize)
						Holder:SetBeautyBorderPadding(BorderPadding)
						Holder:SetBeautyBorderTexture("white")
						--Holder:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
						if Inked.db.profile.ClassABColor == true then
									Holder:SetBeautyBorderColor(InkedColors.r, InkedColors.g, InkedColors.b, InkedColors.a)
								elseif Inked.db.profile.ClassABColor == false then
									if Inked.db.profile.CustomABColor == true then
										Holder:SetBeautyBorderColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
									elseif Inked.db.profile.CustomABColor == false then
										Holder:SetBeautyBorderColor(1,1,1,1)
									end
								end
			end
		end
		
		if Inked.db.profile.AB5Layout == 1 then
		--print("layout 1")
			MultiBarRightButton1:ClearAllPoints()
			MultiBarRightButton1:SetPoint("BOTTOMLEFT", Bar5holder, 0, 0)
			for i = 2, 12 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)
				
			end
			MoverAB5:SetSize((ButtonSize * 12)+12, ButtonSize)
			Bar5holder:SetPoint("LEFT", MoverAB5, 0,-ButtonSize/1.75)
		end
		if Inked.db.profile.AB5Layout == 2 then
	--	print("layout 2")
			MultiBarRightButton1:ClearAllPoints()
			MultiBarRightButton1:SetPoint("BOTTOMLEFT", Bar5holder, 0, 0)
			_G["MultiBarRightButton7"]:ClearAllPoints();
			_G["MultiBarRightButton7"]:SetPoint("BOTTOMLEFT", MultiBarRightButton1, 0, -ButtonSize+(-MySpacing*1.5))
			for i = 2, 6 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)	
			end
			for i = 8,12 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			MoverAB5:SetSize((ButtonSize * 6)+12, (ButtonSize*2) +12)
			Bar5holder:SetPoint("LEFT", MoverAB5, 0,(ButtonSize*0.25))		
		end
		if Inked.db.profile.AB5Layout == 3 then
		--print("layout 3")
			MultiBarRightButton1:ClearAllPoints()
			MultiBarRightButton1:SetPoint("BOTTOMLEFT", Bar5holder, 0, 0)
			_G["MultiBarRightButton5"]:ClearAllPoints();
			_G["MultiBarRightButton5"]:SetPoint("BOTTOMLEFT", MultiBarRightButton1, 0, -ButtonSize+(-MySpacing*4))
			_G["MultiBarRightButton9"]:ClearAllPoints();
			_G["MultiBarRightButton9"]:SetPoint("BOTTOMLEFT", MultiBarRightButton5, 0, -ButtonSize+(-MySpacing*2))
			for i = 2, 4 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)	
			end
			for i = 6,8 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			for i = 10,12 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			MoverAB5:SetSize((ButtonSize * 4), (ButtonSize*3))
			Bar5holder:SetPoint("LEFT", MoverAB5, 0, ButtonSize/1.75)
		end
		if Inked.db.profile.AB5Layout == 4 then
		--print("layout 4")
			MultiBarRightButton1:ClearAllPoints()
			MultiBarRightButton1:SetPoint("BOTTOMLEFT", Bar5holder, 0, 0)
			for i = 2, 12 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))
				
			end
			MoverAB5:SetSize(ButtonSize, (ButtonSize*12) +12)
			Bar5holder:SetPoint("LEFT", MoverAB5, 0,(ButtonSize*5.25))
		end
		if Inked.db.profile.AB5Layout == 5 then
		--print("layout 5")
			MultiBarRightButton1:ClearAllPoints()
			MultiBarRightButton1:SetPoint("BOTTOMLEFT", Bar5holder, 0, 0)
			_G["MultiBarRightButton7"]:ClearAllPoints();
			_G["MultiBarRightButton7"]:SetPoint("BOTTOMLEFT", MultiBarRightButton1, -ButtonSize+(-MySpacing*1.5), 0)
			for i = 2, 6 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 8,12 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))			
			end
			MoverAB5:SetSize((ButtonSize * 2)+12, (ButtonSize*6) +12)
			Bar5holder:SetPoint("LEFT", MoverAB5, ButtonSize,(ButtonSize*2.25))
		end
		if Inked.db.profile.AB5Layout == 6 then
		--print("layout 6")
			MultiBarRightButton1:ClearAllPoints()
			MultiBarRightButton1:SetPoint("BOTTOMLEFT", Bar5holder, 0, 0)
			_G["MultiBarRightButton5"]:ClearAllPoints();
			_G["MultiBarRightButton5"]:SetPoint("BOTTOMLEFT", MultiBarRightButton1, -ButtonSize+(-MySpacing*1.5), 0)
			_G["MultiBarRightButton9"]:ClearAllPoints();
			_G["MultiBarRightButton9"]:SetPoint("BOTTOMLEFT", MultiBarRightButton5, -ButtonSize+(-MySpacing*1.5), 0)

			for i = 2, 4 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 6, 8 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 10,12 do	
				_G["MultiBarRightButton"..i]:ClearAllPoints();
				_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))			
			end
			MoverAB5:SetSize((ButtonSize * 3)+12, (ButtonSize*4) +12)
			Bar5holder:SetPoint("LEFT", MoverAB5, (ButtonSize*2)+2,(ButtonSize*1.25))
			
		end	
		
		for i = 1, 12 do
			local InkedBar5 = _G["MultiBarRightButton"..i]
			_G["MultiBarRightButton"..i]:SetWidth(ButtonSize)
			_G["MultiBarRightButton"..i]:SetHeight(ButtonSize)
			-- _G["MultiBarRightButton"..i]:CreateBeautyBorder(BorderSize)
			-- _G["MultiBarRightButton"..i]:SetBeautyBorderPadding(BorderPadding)
			-- _G["MultiBarRightButton"..i]:SetBeautyBorderTexture("white")
			--_G["MultiBarRightButton"..i]:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			-- if Inked.db.profile.ClassAB5Color == true then
				-- _G["MultiBarRightButton"..i]:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			-- elseif Inked.db.profile.ClassAB5Color == false then
				-- if Inked.db.profile.CustomAB5Color == true then
					-- _G["MultiBarRightButton"..i]:SetBeautyBorderColor(Inked.db.profile.AB5ColorR,Inked.db.profile.AB5ColorG,Inked.db.profile.AB5ColorB,Inked.db.profile.AB5ColorA)
				-- elseif Inked.db.profile.CustomAB5Color == false then
					-- _G["MultiBarRightButton"..i]:SetBeautyBorderColor(1,1,1,1)
				-- end
			-- end

			InkedBar5:SetAttribute("showgrid", 1)
			InkedBar5:SetAttribute("statehidden", false)
			InkedBar5.NormalTexture:SetTexture("")
			local Highlight = InkedBar5:GetHighlightTexture()	
			local Pushed = InkedBar5:GetPushedTexture()
			Highlight:SetTexture(HightlightTex)
			Highlight:SetVertexColor(InkedColorsHightlight.r,InkedColorsHightlight.g,InkedColorsHightlight.b,InkedColorsHightlight.a)
			Pushed:SetTexture(PushedTex)		
		end

		if(Inked.db.profile.lockframes == false) then
			MoverAB5:ClearAllPoints()
			if Inked.db.profile.MoverAB5Point == nil then
				MoverAB5:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB5X,Inked.db.profile.MoverAB5Y)
			else
				MoverAB5:SetPoint(Inked.db.profile.MoverAB5Point, UIParent,Inked.db.profile.MoverAB5X,Inked.db.profile.MoverAB5Y)
			end
			CreateMoverBackdrop(MoverAB5)
			MoverAB5:SetMovable(true)
			MoverAB5:EnableMouse(true)
			MoverAB5:RegisterForDrag("LeftButton")
			MoverAB5:SetScript("OnDragStart", MoverAB5.StartMoving)
			MoverAB5:SetScript("OnDragStop", MoverAB5.StopMovingOrSizing)
			MoverAB5:SetUserPlaced(true)
						
		elseif Inked.db.profile.MoverAB5Point == nil then
				MoverAB5:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB5X,Inked.db.profile.MoverAB5Y)
			else
				MoverAB5:SetPoint(Inked.db.profile.MoverAB5Point, UIParent,Inked.db.profile.MoverAB5X,Inked.db.profile.MoverAB5Y)
		end
		--if Inked.db.profile.AB5Layout == 3 then
			--Bar5holder:SetPoint("LEFT", MoverAB5, 0, 40)
		--end
end		
		local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			MakeBar5()									
		end)